#include<stdio.h>
#include<iostream.h>
#include<conio.h>
#include<string.h>
#include<stdlib.h>
#include<math.h>

void readPGM(char *filename);
void writePGM(char *filename, double **im);
void sobelFilter();

int row, col, numColor; //image rows and cols and max value of grey colors
static char colSize[10], rowSize[10];	//row and cols in the form of string (used at the time of writing an image)
char comments[100];		//for the comments in the image
double **Im1, **Im2;	//global arrays to store the images, source and the target
 
int masky[3][3]={{1,2,1},{0,0,0},{-1,-2,-1}};	//sobel masks
int maskx[3][3]={{-1,0,1},{-2,0,2},{-1,0,1}};

void main()
{
	char *source= "test.pgm";	//source file name
	char *target= "target.pgm";	//target file name
	
	readPGM(source);			//call the function to open the image
	sobelFilter();				//perform sobel edge detection
	writePGM(target, Im2);		//write the image in file
}


// ***************************************************
// ************ open an image from file **************
// ***************************************************

void readPGM(char *filename)

{
	FILE *fptr;
	int r,c,count;
	char buff[100];
	
	if ((fptr = fopen(filename,"rb")) == NULL)
		cout<<"File does not exist!";	//bad source file name
	
	else
		if(fgetc(fptr)!='P')			//check if the source file is in correct format
		{	
			cout<<"Not a PGM file!";
			fclose(fptr);
			exit(0);
		}
		
		
		else 
		{	
			
			fgets(buff,100,fptr);		//inputs the first line in the image (starting from 'P')
			fgets(comments,100,fptr);	//comments are stored in char array comments
			count=0;
			
			while( (buff[count]=fgetc(fptr)) != ' ') count ++;
			buff[count]='\0';
			col = atoi (buff);			//read number of cols and rows and convrets char to int
			
			fgets(buff,100,fptr);		
			row = atoi (buff);		
			
			fgets(buff,100,fptr);		//read max grey level
			numColor = atoi (buff);		
			
			
			
			Im1 = new double*[row];		//assign memory to source and target arrays
			Im2 = new double*[row];
			for (r=0; r<row; r++)
			{
				Im1[r]=new double[col];
				Im2[r]=new double[col];
			}
			
			for (r=0; r<row; r++)		//read image from the file and loads in the array
				for (c=0; c<col; c++)
					Im1[r][c] = fgetc(fptr);
			fclose(fptr);				//close the file pointer
		}		
}



//******************************************************
//**************** write image in a file ***************
//******************************************************
void writePGM(char *filename, double **im)
{
	int r, c;
	
	FILE *fptr;
	
	fptr = fopen(filename,"wb");		//create target file
	
	fputs("P5",fptr);					//format for pgm
	fputc('\n',fptr);
	
	fputs("#this is demo image in binaray format",fptr);	//comments
	fputc('\n',fptr); 
	
	fprintf( fptr, "%d %d\n255\n", col, row) ;

	for (r=0; r<row; r++)				//write the file
		for (c=0; c<col; c++)
			fputc(unsigned char (im[r][c]) ,fptr);
	fclose(fptr);						//close the file pointer
}


void sobelFilter()
{
	double Sx, Sy;						//variables to hold partial derivatives' values
	int r,c,i,j;
	double sobelTH=225;					//sobel threshold
	
	for(r=1; r<row-1; r++)
		for(c=1; c<col-1; c++)
		{	
			Sx=0;						//initialize derivative values
			Sy=0;
			for (i=0; i<3; i++)			//convolve the mask
				for (j=0; j<3; j++)
				{
					Sx = Sx+ Im1[r+i-1][c+j-1]*maskx[i][j];
					Sy = Sy+ Im1[r+i-1][c+j-1]*masky[i][j];
				}

	
				if(sqrt(Sx*Sx+Sy*Sy)>sobelTH)
					Im2[r][c]=255;		//mark the pixel if derivative is greater than threshold
				else 
					Im2[r][c]=0;		//or leave it dark
		}
}

